package gs.admin;

import java.util.Hashtable;

import java.io.IOException;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpUtils;


import gs.db.update;
import gs.db.dbUser;
import gs.db.U;

import java.sql.ResultSet;

import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;


/**
 */
public class gAdmin extends HttpServlet {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */

  public static gSystem  sys=new gSystem();



  public void doPost  (HttpServletRequest req,HttpServletResponse response) 
       throws IOException, ServletException 
  {
    processInOut( req,response);
  }

  public void doGet(HttpServletRequest req, HttpServletResponse response)
       throws IOException, ServletException
  {
    processInOut( req,response);
  }


  public void processInOut (HttpServletRequest req,HttpServletResponse response)
       throws IOException, ServletException
  {

    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();
    String templateFile = req.getPathTranslated();
    String unum = req.getParameter("unum"); 
    String command = req.getParameter("comm"); 

    if (command == null )
      return;
    try {
      if(command.equals("access")) {
	checkUser(out, req.getPathTranslated(), 
		  req.getParameter("login"),req.getParameter("password"));
	return;
      }
      sys.accessPermission(unum,"ALL","USER_RECORDS:"+command);

      if(command.equals("LISTALL"))
	listUsers(out, unum, req.getPathTranslated(), true);

      else if(command.equals("FRAME"))
	decideFrame(out, unum, req.getPathTranslated(), 
		    req.getParameter("framecomm"),
		    req.getParameter("file"), req.getParameter("gslogin"));


      else if(command.equals("NEW"))
	newUserFrame(out, unum, req.getPathTranslated());

      else if(command.equals("NEWRECORD"))
	newUserRecord(out, unum, req.getPathTranslated());

      else if(command.equals("SKIP"))
	skip(out, unum, req.getPathTranslated());

      else if(command.equals("INFO"))
	infoPage(out, unum, req.getPathTranslated());

      else if(command.equals("CANCEL"))
	out.println("<script language=JavaScript> history.go(-2);</script>");

      else if(command.equals("EDIT"))
	editUserFrame(out, unum, req.getPathTranslated(),
		      (String)(req.getParameter("gslogin")));

      else if(command.equals("EDITRECORD"))
	editUserRecord(out, unum, req.getPathTranslated(),
		       (String)(req.getParameter("gslogin")));

      else if(command.equals("DELETE"))
	deleteUser(out, unum, req.getPathTranslated(),
		   (String)(req.getParameter("gslogin")), 
		   (String)(req.getParameter("answer")));


    } catch (Exception e) {
       sys.error(out,e);
       //e.printStackTrace();
       //sys.error(out,e.getMessage());
    }

    //    out.println( Html.footer() );
    out.close();
  
  }


  //--------------------------------------------------------------------//
  //checkUser(
  //--------------------------------------------------------------------//
  public void checkUser(ServletOutputStream out, String templateFile,
		   String gslogin, String gspwd)
       throws Exception , IOException 
  {
    int privilige=0;
    //System.out.println("gslogin"+gslogin);
    //System.out.println("gspwd"+gspwd);
    try {
      dbUser u=sys.usr_cache.get(gslogin);
      //System.out.println("u.gspwd"+gslogin);
      //System.out.println("u.gspwd"+gspwd);
      if (!u.gspwd.equals(gspwd))
	throw new Exception("UserNotFound");
      privilige=Integer.parseInt((String) u.fields.get("privilige"));
      
    } catch (Exception e) {
      //throw e;
      if (e.getMessage().indexOf("UserNotFound") >=0) 
      throw new Exception("Access denied; Invalid login and password combination.");
    }
    
    try {
      Hashtable ht = new Hashtable();
      String unum= gslogin;       ///sys.usr_cache.getIdNumber(gslogin);
      sys.globalValues(ht,unum);
      ht.put("privilige",U.getPrivilige(privilige));
      Parser.parseHtml(templateFile,ht , out);
    } catch(Exception e) {
      throw new Exception("While loading menu page for  user "+gslogin+": "+e.getMessage());
    }
  }
  //--------------------------------------------------------------------//
  //insertFirstUser
  //--------------------------------------------------------------------//
  public static void insertFirstUser(String pwd)       throws Exception , IOException 
  {
    
    dbUser u=new dbUser();

      u.fields.put("idnum"     , "1");
      u.fields.put("privilige" , "0");
      u.fields.put("ACL"       , "");
      u.fields.put("email"     , ""); 
      u.fields.put("dept"      ,""); 
      u.fields.put("url"       , "url");  
      u.fields.put("picurl"    , "picurl");  
      u.fields.put("phone"     , "phone"); 
      u.fields.put("room"      , "room");  
      u.fields.put("systemslogin"   , "");
      u.fields.put("comments"  , "remove me later");
      u.fields.put("reserved"  , "");
      //  u.fields.put("oldgslogin"  , req.getParameter("oldgslogin"));
    u.fields.put("gslogin"     , "admin");    
    u.fields.put("firstname"   , "Admin");    
    u.fields.put("midname"     , "A.");    
    u.fields.put("lastname"    , "Administrator");    
    u.fields.put("gspwd"       , pwd);    
    u.setIdentification();
    
      sys.usr_cache.add(u);

  }
  //--------------------------------------------------------------------//
  // findRestrictedList
  //--------------------------------------------------------------------//  
  public String findRestrictedList(String acl){
    return "<OPTION>me";
  }

  //--------------------------------------------------------------------//
  // List ALL users 
  //--------------------------------------------------------------------//  
  void listUsers(ServletOutputStream out, String unum, String templateFile, boolean allFields)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);

      String fieldNames = "gslogin,firstname,midname,lastname,url";
      String queryProjection = fieldNames;
      dbUser u = new dbUser();

      if(allFields) 	{
	fieldNames = u.getFieldNames();
	queryProjection = "*";
      }
      ResultSet rs = u.records(queryProjection,"","lastname,firstname");
      Parser.parseHtml(templateFile, ht, out,  new RecordParser(rs, fieldNames));
  }


  //--------------------------------------------------------------------//
  // open new user page using frames
  //--------------------------------------------------------------------//  
  void newUserFrame  (ServletOutputStream out, String unum, String templateFile)
       throws  Exception, IOException
  {
      Hashtable ht= new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("framecomm", "NEWRECORD");
      ht.put("gslogin", "__new___");
      ht.put("file", "new.html");
      Parser.parseHtml(templateFile, ht, out);
  }

  //--------------------------------------------------------------------//
  // open new user record form in a frame 
  //--------------------------------------------------------------------//  
  void newUserRecord(ServletOutputStream out, String unum, String templateFile) 
       throws Exception, IOException
  {
      Hashtable ht = dbUser.getEmptyFields();
      sys.globalValues(ht,unum);
      String rcl=findRestrictedList("");
      ht.put("rcl",rcl);
      Parser.parseHtml(templateFile, ht, out);
  }

  //--------------------------------------------------------------------//
  // open the page to  edit an existing user
  //--------------------------------------------------------------------//  
  void editUserFrame (ServletOutputStream out, String unum, 
		      String templateFile, String gslogin)        
       throws Exception,IOException
  {
      Hashtable ht= new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("framecomm", "EDITRECORD");
      ht.put("gslogin", gslogin);
      ht.put("file", "edit.html");
      Parser.parseHtml(templateFile, ht, out);
  }
  //--------------------------------------------------------------------//
  //  editUserRecord page
  //--------------------------------------------------------------------//  
  void editUserRecord (ServletOutputStream out, String unum, 
		       String templateFile, String gslogin)        
       throws  Exception, IOException
  {
      Hashtable ht=dbUser.getFields(gslogin);
      sys.globalValues(ht,unum);
      String rcl=findRestrictedList((String)ht.get("ACL"));
      ht.put("rcl",rcl);
      Parser.parseHtml(templateFile, ht, out);
  }

  //--------------------------------------------------------------------//
  // DELETE a user
  //--------------------------------------------------------------------//  
  void deleteUser (ServletOutputStream out, String unum,
		   String templateFile, String gslogin, String answer) 
       throws Exception, IOException
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      if(answer == null) {
	int pos=templateFile.lastIndexOf( (int) '/');
	templateFile=templateFile.substring(0,pos)+"/confirm.html";
	ht.put("message", "<br>Do you really want to delete the user <i>"+gslogin+"</i>?");
	ht.put("actionurl", "updatemessage.html");
	ht.put("comm","DELETE");	
	ht.put("gslogin",gslogin);
      } 
      else if(answer.equals("YES")) {
	dbUser.delete(gslogin);
	ht.put("message", "User information has been succesfully deleted!");
      }
      else if(answer.equals("NO")) {
	out.println("<script language=JavaScript> history.go(-2);</script>");
      }
      Parser.parseHtml(templateFile, ht, out);
      
  }

  //--------------------------------------------------------------------//
  // add new User
  //--------------------------------------------------------------------//  
  void addUser(ServletOutputStream out, String unum, dbUser dbu, String templateFile )
       throws Exception,IOException
  {
    try {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      dbu.add();
      ht.put("message", "User addition comleted successfully!");
      ht.put("script", "");
      ht.put("framecomm", "SHOW");
      ht.put("gslogin", dbu.gslogin);
      ht.put("file", "browse.html");
      Parser.parseHtml(templateFile, ht, out);
	
    } catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	error= new String("This user login id exists in the system. <br> Please try another one.");
	}
      throw new Exception(error);
    }    
  }
  //--------------------------------------------------------------------//
  // 
  //--------------------------------------------------------------------//  
  void skip(ServletOutputStream out, String unum,String templateFile) 
       throws Exception,IOException
  {
      int pos=templateFile.lastIndexOf( (int) '/');
      templateFile=templateFile.substring(0,pos)+"/info.html";
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      Parser.parseHtml(templateFile,ht,out);
  }
  //--------------------------------------------------------------------//
  // info page
  //--------------------------------------------------------------------//  
  void infoPage(ServletOutputStream out, String unum,String templateFile) 
       throws Exception,IOException
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      Parser.parseHtml(templateFile,ht,out);
  }
  //--------------------------------------------------------------------//
  // 
  //--------------------------------------------------------------------//  
  void  decideFrame(ServletOutputStream out, String unum ,String path,
		    String  framecomm, String file, String gslogin) 
       throws  Exception,IOException
  {
    //try {
    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    ht.put("framecomm", framecomm);
    ht.put("file", file);
    ht.put("gslogin",gslogin);
    Parser.parseHtml(path,ht,out);
    //} catch( Exception e ) {
    //e.printStackTrace();
    // out.println( Html.header("User Records") );
    //String error =e.getMessage();
    //out.println("<h2>ERROR: "+error+" at guser.frame");
    //out.println("<HR>");
    // out.println( Html.footer() );
    //}   
  }


} //class close

