package gs.cache;

import java.util.Hashtable;
import gs.db.dbCourse;




public class CourseCache {
  static int miss=0;
  static int hit=0;
   public static int size=20;
  static Hashtable courseht=new Hashtable(size);
  static Hashtable index=new Hashtable(size);   //Integer,accesscode
  static int counter=0;

  public CourseCache(){  }
  public static void clear(){
    courseht.clear();
    index.clear();
    counter =0;
  }
 //--------------------------------------------------------------------//
  // LOAD putIntoCache
  //--------------------------------------------------------------------//
  public synchronized static  void putIntoCache(String title,dbCourse c){
    try {
      String REMOVE=Integer.toString(counter);
      index.remove(REMOVE);
      String oldkey=(String)index.get(REMOVE);
      courseht.remove(oldkey); 
    }
    catch (Exception e) {//System.out.println(" not existing");
    } 
    index.put(Integer.toString(counter),title);
    courseht.put(title,c);

    counter++;
    counter%=size;
  }

  //--------------------------------------------------------------------//
  //dbCourse get( String title)
  //--------------------------------------------------------------------//
  public  synchronized static dbCourse get( String title)    throws Exception 
  {
    dbCourse c= (dbCourse)courseht.get(title);
    if (c==null) {
      try {
	c= new dbCourse(title);
	putIntoCache(title,c); 
	miss++;courseht.put(title,c);
	miss++;
      } catch (Exception e) {
	  throw e;
      }
    } else {hit++;}
    //System.out.println("==========course=============");
    //System.out.println("MISS "+miss+ " HIT "+hit);
    return c;
  }

  //--------------------------------------------------------------------//
  // delete course
  //--------------------------------------------------------------------//  
 
  public static void  delete(String title)  throws Exception
  {
    dbCourse.delete(title);
    courseht.remove(title);

  }
  //--------------------------------------------------------------------//
  // add course
  //--------------------------------------------------------------------//  
 
  public static void  add(dbCourse dbu)  throws Exception
  {
    dbu.add();
    courseht.put(dbu.title,dbu);
  }
  //--------------------------------------------------------------------//
  // update course
  //--------------------------------------------------------------------//  
 
  public static void  update(dbCourse dbc)  throws Exception
  {
    courseht.remove(dbc.title);
    dbc.update();
    courseht.put(dbc.title,dbc);
  }

}
