package gs.db;

//import gs.object.aUser;
import gs.db.database;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public class dbCustomizedGrade extends database {

  public       String course;          // unique key
  public       String grade;          // unique key

  public  static String tablename="customizedgrades";
  public  static String fieldnames="course,grade,points";

  public dbCustomizedGrade() {}
  public dbCustomizedGrade( String course,String grade )        throws Exception
  {
    String queryString = "SELECT * from "+ getTableName() +
       " WHERE course ='"+ course +"' AND grade='"+grade+"'";
  try {
      ResultSet rs = query.queryData( queryString );
      System.out.println("dbCustomizedGrade:queryString:"+queryString);
      if( rs.next() )
	{
	  fields.put("course",  Integer.toString(rs.getInt("course")));
	  fields.put("grade", (String)rs.getString("grade"));
	  fields.put("points", (String)rs.getString("points")); 

	  setIdentification();
	} else {
	 
	  throw new Exception("dbCustomizedGrade:GradeNotFound: Grade could not be found.(dbCustomizedGrade)");
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
  }
  //--------------------------------------------------------
   public void setIdentification(){

     this.course     = (String) fields.get("course");
     this.grade    = (String) fields.get("grade");
  }
  //-----------------make- remove---------------------------------------
 
  public void makeGrade(String course,String grade,String points) throws Exception
  {
    try {    removeGrade(course,grade); }
    catch (Exception e){} 
    fields.put("course", course);
    fields.put("grade",grade );
    fields.put("points",points );
    setIdentification();
    add();
  }
  //--------------------------------------------------------
   public void removeGrade(String course,String grade) throws Exception
  {
     String sqlcommand= deleteSQL("course='"+ course+"' AND grade='"+grade+"'" );
    update.updateData(sqlcommand );
  }

  //--------------------------------------------------------
  public static Hashtable getFields(String course,String  grade)  throws Exception
  {
    return new dbCustomizedGrade(course,grade).getFields(); // super class' method
  }

  //--------------------------------------------------------
   public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable result = new Hashtable();
    result.put("course",	""); 
    result.put("grade",	""); 
    result.put("points",	""); 

    return result;
  }

   //--------------------------------------------------------
  public String getTableName()
  {
    return tablename;
  }
  /*  public  int findMaxQN() throws Exception
  {
    int max=0;
    int qn;
    ResultSet rs=records("course","","");

    while (rs.next()){
      qn=rs.getInt("course");
      if (qn>max) max=qn;
    }
      
    return max;
  }
  */
  //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  // used in SQL INSERT command
  public  String getFieldNames()
  {
    return fieldnames;
  }

  // used in SQL INSERT command
  //--------------------------------------------------------
   public String getFieldValues()
  {
    return                           "'"+ 
      (String)fields.get("course")	+"','"+ 
      (String)fields.get("grade")	+"',"+ 
      (String)fields.get("points")	;
  }

  //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

  // used in SQL UPDATE command
  //--------------------------------------------------------
   public String getSetValues()
  {
    return "course='"          + (String)fields.get("course")
      +"',grade='"              + (String)fields.get("grade")
      +"',points="              + (String)fields.get("points") 
      ;
  }
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //            OPERATIONS
  // \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \

  //CONSIDER LATER
  //--------------------------------------------------------
   public String updateSQL()   {
    return updateSQL("course='"+course  +"' AND grade='"+grade+"'");
  }
  //--------------------------------------------------------
   public void update()throws Exception {
      update.updateData( updateSQL() );
  }


  //--------------------------------------------------------
   public void add()throws Exception {
    try {
      update.updateData( insertSQL() );
    } catch (Exception e) {
      update();
    }
  }

}







