 package gs.dbxml;

//XML
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;
import com.ibm.xml.parsers.*;

//XML-end

import gs.db.update;
import gs.db.database;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public class dbxQuiz extends database {

  public  String    course  ;          // unique key
  public   String   quizname      ;// unique key
  public   String accesscode;
  public   String idnum;
  public   long  expire;




  static       String tablename="quizzes";

  public dbxQuiz() {}
  public dbxQuiz(String course) { this.course=course;}
  public Document dbxQuiz( String _course,String _quizname )        throws Exception
  {
    
    String queryString = "SELECT * from "+ getTableName() +
      " WHERE  quizname='"+ _quizname +"' AND course='"+_course+"'";

	TXDocument dxml= new TXDocument();
	Document d= (Document) dxml;
	//Document d1= (new TXDOMParser()).getDocument();
	//there is nicer way for it remember it
	Element crs=d.createElement("course");
	Element crsname=d.createElement("coursename");
	Text ct =d.createTextNode(_course);
	crsname.appendChild(ct);
	crs.appendChild(crsname);
    try 
      {
	ResultSet rs = query.queryData( queryString );
	System.out.println("dbxQuiz:queryString:"+queryString);

	if( rs.next() )
	  {
	    System.out.println("queryString: FOUND");

	    String quizname = (String)rs.getString("quizname");
	    String starttime = (String)rs.getString("starttime");
	    String endtime = (String)rs.getString("endtime");
	    String duration = (String)rs.getString("duration");
	    String points = (String)rs.getString("points");
	    String settingsI = (String)rs.getString("settingsI");
	    String settingsII = (String)rs.getString("settingsII");
	    String settingsIII = (String)rs.getString("settingsIII");

	  
	    Element quiz=d.createElement("quiz");
	    Element qname=d.createElement("quizname");
	    Text t =d.createTextNode(quizname);
	    System.out.println("quizname -->"+quizname);
	  
	    qname.appendChild(t);
	    quiz.appendChild(qname);
	    crs.appendChild(quiz);
	    d.appendChild(crs);

	    Element qduration=d.createElement("duration");
	    t=d.createTextNode(duration);
	    qduration.appendChild(t);
	    quiz.appendChild(qduration);
	    System.out.println("duration -->"+duration);


	    Element qpoints=d.createElement("points");
	    t=d.createTextNode(points);
	    qpoints.appendChild(t);
	    quiz.appendChild(qpoints);

	    Element qsettingsI=d.createElement("settingsI");
	    t=d.createTextNode(settingsI);
	    qsettingsI.appendChild(t);
	    quiz.appendChild(qsettingsI);

	    Element qsettingsII=d.createElement("settingsII");
	    t=d.createTextNode(settingsII);
	    qsettingsII.appendChild(t);
	    quiz.appendChild(qsettingsII);

	    Element qsettingsIII=d.createElement("settingsIII");
	    t=d.createTextNode(settingsIII);
	    qsettingsIII.appendChild(t);
	    quiz.appendChild(qsettingsIII);



	  //       Node qw=new Node();
	  //       Node as =new Node();
	  //       qw.append(as);
	    /*    fields.put("accesscode", (String)rs.getString("accesscode"));
	    fields.put("oldaccesscode", (String)rs.getString("accesscode"));
	    fields.put("gspwd", (String)rs.getString("gspwd"));
	    fields.put("course", (String)rs.getString("course"));
	    fields.put("Quizid", (String)rs.getString("Quizid"));
	    fields.put("idnum", (String)rs.getString("idnum"));
	    fields.put("firstname", (String)rs.getString("firstname")); 
	    fields.put("midname", (String)rs.getString("midname"));
	    fields.put("lastname", (String)rs.getString("lastname")); 
	    fields.put("email", (String)rs.getString("email")); 
	    fields.put("dept", (String)rs.getString("dept")); 
	    fields.put("url", (String)rs.getString("url")); 
	    fields.put("picurl", (String)rs.getString("picurl")); 
	    fields.put("class", (String)rs.getString("class")); 
	    fields.put("systemslogin", (String)rs.getString("systemslogin")); 
	    fields.put("systemspwd", (String)rs.getString("systemspwd")); 
	    setIdentification();
	    */
	  } else {
	    throw new Exception("GS:dbxQuiz:QuizNotFound: Quiz could not be found.(dbxQuiz)");
	  }
      } catch(Exception e) {
	e.printStackTrace();
	throw e;
      }
      return d;

  }
  /*  
  public Document QuizAsXMLDocument(String accesscode,String course )        throws Exception
  {
    

      ResultSet rs = query.queryData( queryString );
      System.out.println("XML:dbxQuiz:queryString:"+queryString);
      


      if( rs.next() )
	{
	     System.out.println("queryString: FOUND");
   
	  fields.put("accesscode", (String)rs.getString("accesscode"));
	  fields.put("oldaccesscode", (String)rs.getString("accesscode"));
	  fields.put("gspwd", (String)rs.getString("gspwd"));
	  fields.put("course", (String)rs.getString("course"));
	  fields.put("Quizid", (String)rs.getString("Quizid"));
	  fields.put("idnum", (String)rs.getString("idnum"));
	  fields.put("firstname", (String)rs.getString("firstname")); 
	  fields.put("midname", (String)rs.getString("midname"));
	  fields.put("lastname", (String)rs.getString("lastname")); 
	  fields.put("email", (String)rs.getString("email")); 
	  fields.put("dept", (String)rs.getString("dept")); 
	  fields.put("url", (String)rs.getString("url")); 
	  fields.put("picurl", (String)rs.getString("picurl")); 
	  fields.put("class", (String)rs.getString("class")); 
	  fields.put("systemslogin", (String)rs.getString("systemslogin")); 
	  fields.put("systemspwd", (String)rs.getString("systemspwd")); 
	  setIdentification();
	} else {
	 
	  throw new Exception("GS:dbxQuiz:QuizNotFound: Quiz could not be found.(dbxQuiz)");
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
    return d;

  }

  */



  public void setIdentification(){

    //     this.accesscode     = (String) fields.get("accesscode");
    // this.gspwd     = (String)fields.get("gspwd"); 
    // this.course     = (String)fields.get("course"); 

     String idstr= (String)fields.get("idnum"); 
     int Z=idstr.indexOf((int) 'Z');
     if (Z>=0) {
       //       this.idnum = idstr.substring(0,Z);
       String timeString= idstr.substring(Z+1);
       //       this.expire =  Long.parseLong(timeString);
     } else {
       //       this.idnum =idstr;
       //this.expire =-1;
     }

  }
   public void setidnum(String idn){
    fields.put("idnum", idn);
    //    this.idnum     = idn;
  }
 
  public static String checkQuizID (String id) throws Exception {
    String queryString = "SELECT accesscode from "+ tablename +
       " WHERE idnum ='"+ id +"'";
    try {
      ResultSet rs = query.queryData( queryString );
      //System.out.println("dbxQuiz:queryString:checkQuizID:"+queryString);
      if( rs.next() )
	{
	  return (String)rs.getString("accesscode");
	} else {
	  return null;
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
  }

  public  void makeIDHardCopy()throws Exception {
    update.updateData( "UPDATE "+ getTableName()
      + " SET  idnum='" + idnum+ "Z"+Long.toString(expire)+ "'"
      + " WHERE accesscode='" +accesscode+"' AND course='"+course+"'");
  }

  public static dbxQuiz  findbyIdNumber(String idnum)  throws Exception {
    return new dbxQuiz(checkQuizID (idnum) );
    }
 
  public  boolean uniqueness(String []pwcr)  throws Exception {
    String queryString = "SELECT accesscode,gspwd,course from "+ tablename +" WHERE accesscode='"+accesscode+"'";
    ResultSet rs = query.queryData( queryString );
    boolean    unique=true;
    boolean    samecourse=false;
    while ( rs.next() ) {
      unique=false;
      if (course.equals((String)rs.getString("course")))
	samecourse=true;
      pwcr[0]=(String)rs.getString("gspwd");
      pwcr[1]=(String)rs.getString("course");
    }
    if (samecourse) pwcr[1]=course;
    return unique;
  }
  public static boolean existence(String loginid) throws Exception{
    String queryString = "SELECT accesscode from "+ tablename +" WHERE accesscode='"+loginid+"'";
    ResultSet rs = query.queryData( queryString );
    if( rs.next() )
      return true;
    return false;
  }

  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public   ResultSet listQuizs ( boolean allFields) throws Exception
  {
      String queryProjection ="accesscode,firstname,midname,lastname,url";
      if(allFields) 	{
	queryProjection = "*";
      }
      return records(queryProjection,"course='"+course+"'","lastname,firstname");
  }
  public     String  listQuizsFields(boolean allFields ) throws Exception
  {
    if(allFields) 	
      return getFieldNames();
    return "accesscode,firstname,midname,lastname,url";
  }
  

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  ResultSet classList(String course) throws Exception
  {

    String fieldNames = "firstname,midname,lastname,email,url,picurl";
    String queryProjection = fieldNames;
    ResultSet rs = records(queryProjection,"course='"+course+"'", "lastname,firstname");
    return rs;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public    String  classListFields(String course) throws Exception
  {
    return "firstname,midname,lastname,email,url,picurl";
  }
 
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  ResultSet classPasswordList(String course) throws Exception
  {

    String fieldNames = "accesscode,firstname,midname,lastname,email,url,systemslogin,systemspwd";
    String queryProjection = fieldNames;
    ResultSet rs = records(queryProjection,"course='"+course+"'", "lastname,firstname");
    return rs;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public    String  classPasswordListFields(String course) throws Exception
  {
    return "accesscode,firstname,midname,lastname,email,url,systemslogin,systemspwd";
  }
    
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public String  majordomoList(String course, String []emails) throws Exception
  {
    
emails[0]="";
emails[1]="";
emails[2]="";
    String fieldNames = "firstname,midname,lastname,email,systemslogin";
    String queryProjection = fieldNames;
    ResultSet rs = records(queryProjection,"course='"+course+"'", "lastname,firstname");
    while (rs.next()){
      if (((String)rs.getString("systemslogin")).equals(""))
	emails[1]+=(String)rs.getString("firstname")+" "+(String)rs.getString("midname")+" "+(String)rs.getString("lastname")+"<br>";
      else if (((String)rs.getString("email")).equals(""))
	emails[2]+=(String)rs.getString("firstname")+" "+(String)rs.getString("midname")+" "+(String)rs.getString("lastname")+"<br>";
      else
	emails[0]+=(String)rs.getString("email")+",\n";
    
      //course +=course;
    }
    return course;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public    String  majordomoListFields(String course) throws Exception
  {
    return "accesscode,firstname,midname,lastname,email,url,systemslogin,systemspwd";
  }
    
  public String postOffice(String course) throws Exception {
    String queryString = "SELECT firstname, midname, lastname,email,url,picurl  from "+ tablename +
      " WHERE course = '"+course +"' ORDER BY lastname,firstname";
    String out="";
    try {
      ResultSet rs = query.queryData( queryString );
      while (rs.next() ) {
	String picurl=(String)rs.getString("picurl");
	String url=(String)rs.getString("url");
	String name=(String)rs.getString("lastname")+", "+(String)rs.getString("firstname")+" "+ (String)rs.getString("midname") ;
	
	  out+="recipient[n++] = new Recipient('"+name +"' ";
	  out+=",'Quizs'";
	  out+=",'"+url+"'";
	  out+=",'"+picurl+"'"; 
	  out+=",'"+ (String)rs.getString("email")+"');";
      }
    }catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
    //System.out.println("out++>"+out+" course"+course);
    return out;
  }


  public static Hashtable getFields(String accesscode)  throws Exception
  {
    return new dbxQuiz(accesscode).getFields(); // super class' method
  }

  public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable result = new Hashtable();
    result.put("accesscode", "");
    result.put("gspwd", "");
    result.put("course", "");
    result.put("Quizid", "5"); 
    result.put("idnum", ""); 
    result.put("firstname", ""); 
    result.put("midname", "");
    result.put("lastname", ""); 
    result.put("email", ""); 
    result.put("dept", ""); 
    result.put("url", ""); 
    result.put("picurl", ""); 
    result.put("class", ""); 
    result.put("systemslogin","" ); 
    result.put("systemspwd","" ); 

    return result;
  }

  public String getTableName()
  {
    return tablename;
  }
  //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  // used in SQL INSERT command
  public String getFieldNames()
  {
    return "accesscode,gspwd,course,"+
      "Quizid,idnum,"+
      "firstname,midname,lastname,"+
      "email,dept,url,picurl,class,systemslogin,"+
      "systemspwd";
  }

  // used in SQL INSERT command
  public String getFieldValues()
  {
    return                           "'"+ 
      (String)fields.get("accesscode")          +"','"+ 
      (String)fields.get("gspwd")            +"','"+ 
      (String)fields.get("course")            +"','"+ 
      (String)fields.get("Quizid")        +"','"+
      (String)fields.get("idnum")              +"','"+
      (String)fields.get("firstname")        +"','"+
      (String)fields.get("midname")          +"','"+ 
      (String)fields.get("lastname")         +"','"+ 
      (String)fields.get("email")            +"','"+
      (String)fields.get("dept")             + "','"+
      (String)fields.get("url")              +"','"+ 
      (String)fields.get("picurl")           +"','"+
      (String)fields.get("class")            +"','"+
      (String)fields.get("systemslogin")     +"','"+
      (String)fields.get("systemspwd")         +"'";
  }

  //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

  // used in SQL UPDATE command
  public String getSetValues()
  {
    return "accesscode='"          + (String)fields.get("accesscode")
      +"',gspwd='"              + (String)fields.get("gspwd") 
      +"',course='"              + (String)fields.get("course") 
      +"',Quizid='"          + (String)fields.get("Quizid") 
      +"',idnum='"                + (String)fields.get("idnum") 

      +"',firstname='"          + (String)fields.get("firstname") 
      +"',midname='"            + (String)fields.get("midname") 
      +"',lastname='"           + (String)fields.get("lastname")
      +"',email='"              + (String)fields.get("email") 
      +"',dept='"               + (String)fields.get("dept") 
      +"',url='"                + (String)fields.get("url") 
      +"',picurl='"             + (String)fields.get("picurl") 
      +"',class='"              + (String)fields.get("class") 

      +"',systemslogin='"       + (String)fields.get("systemslogin") 
      +"',systemspwd='"           + (String)fields.get("systemspwd")
      +"'";
  }
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //            OPERATIONS
  // \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  void changePassword( String accode,String crs, String sysl,String  syspwd )throws Exception{
     update.updateData( 
	    updateFieldsSQL("systemslogin='"+sysl+"',systemspwd='"+syspwd+"'"
			    ,"accesscode='"+accode  +"' AND course='"+crs+"'") );
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //CONSIDER LATER
  public String updateSQL()  throws Exception {
    String oldaccesscode=(String)fields.get("oldaccesscode");
    if (!oldaccesscode.equals(accesscode)) {
      String updatestr=" SET accesscode='"+accesscode+"' WHERE accesscode ='"+oldaccesscode+"' AND course='"+course+"'";
      update.updateData( "UPDATE answers "+updatestr);
      update.updateData( "UPDATE grades "+updatestr);
      update.updateData( "UPDATE performances "+updatestr);
    }
    return updateSQL("accesscode='"+oldaccesscode  +"' AND course='"+course+"'");
  }
  public void update()throws Exception {
      update.updateData( updateSQL() );
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public static void  delete(String _accesscode,String _course) throws Exception{
    //    String sqlcommand=new dbxQuiz().deleteSQL("accesscode='"+ _accesscode +"'");
    //    update.updateData(sqlcommand );
    String deleteStr= "accesscode='"+ _accesscode +"' AND course='"+_course+"'";
    update.updateData( "DELETE FROM Quizs WHERE "+deleteStr);

    update.updateData( "DELETE FROM answers WHERE "+deleteStr);
    update.updateData( "DELETE FROM grades WHERE "+deleteStr);
    update.updateData( "DELETE FROM performances WHERE "+deleteStr);
  }
  //CONSIDER LATER
  //  public String deleteSQL() {
  //   return deleteSQL("accesscode='"+ accesscode +"'");
  //  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void add()throws Exception {
      update.updateData( insertSQL() );
  }

}







