package gs.html;

import java.util.StringTokenizer;
import java.util.Hashtable;

import java.sql.ResultSet;

public class RecordParser
       implements gs.html.RecordParsable
{
  ResultSet rs;
  String fieldNames;
  String intoNames;
  
  public RecordParser(ResultSet rs, String fieldNames)
  {
    this.rs = rs;
    this.fieldNames = fieldNames;
    this.intoNames=fieldNames;
  }
  public RecordParser(ResultSet rs, String fieldNames,String intoNames)
  {
    this.rs = rs;
    this.fieldNames =  fieldNames;
    this.intoNames=  intoNames;
  }
  
  public boolean handleRecord(Hashtable fields)
       throws java.io.IOException, java.sql.SQLException
  {
    if(rs.next()) 
      {
	StringTokenizer names = new StringTokenizer(fieldNames, " ,");;
	String aField;
	StringTokenizer putnames = new StringTokenizer(intoNames, " ,");;
	String putField;
	while(names.hasMoreElements()) 
	  {
	    aField = names.nextToken();
	    putField = putnames.nextToken();
	    fields.put(putField, rs.getString(aField));
	  }
	return true;
      }
    return false;
  }
   public int findMaxQN(ResultSet rs) throws java.sql.SQLException
  {
    int max=0;
    int qn;
    while (rs.next()){
      qn=rs.getInt("qid");
      if (qn>max) max=qn;
    }
      
    return max;
  }
 


}






