package gs.cache;

import java.util.Hashtable;

import java.io.IOException;
import javax.servlet.ServletException;

import javax.servlet.ServletOutputStream;


import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;

import gs.cache.UserCache;

//import java.util.Date;
import java.util.Random;
import gs.db.dbUser;




public class UserCache {
  static int miss=0;
  static int hit=0;
   public static int size=20;
  static Hashtable userht=new Hashtable(size);
  //  static Hashtable idht=new Hashtable(size);
  static Hashtable index=new Hashtable(size);   //Integer,accesscode
  static int counter=0;
  public UserCache(){  }
  public static void clear(){
    userht.clear();
    index.clear();
    counter =0;
  }

  public synchronized static  void putIntoCache(String gslogin ,dbUser  u){
    try {
      String REMOVE=Integer.toString(counter);
      index.remove(REMOVE);
      String oldkey=(String)index.get(REMOVE);
      userht.remove(oldkey); 
    }
    catch (Exception e) {//System.out.println(" not existing");
    } 
    index.put(Integer.toString(counter),gslogin);
    userht.put(gslogin,u);

    counter++;
    counter%=size;
  }


  //--------------------------------------------------------------------//
  //dbUser get( String gslogin)
  //--------------------------------------------------------------------//
  public synchronized static dbUser get( String gslogin)    throws Exception , IOException 
  {
    dbUser u= (dbUser)userht.get(gslogin);
    if (u==null) {
      try {
	u= new dbUser(gslogin);
        setIdNumber(gslogin,u);
	putIntoCache(gslogin,u); 
	miss++;
      } catch (Exception e) {
	  throw e;
      }
    } else {hit++;}
    //System.out.println("=======================");
    //System.out.println("MISS "+miss+ " HIT "+hit);
    checkIdExpiration(gslogin);
    return u;
  }
  //--------------------------------------------------------------------//
  // getIdNumber(String gslogin)
  //--------------------------------------------------------------------//
  public static String getIdNumber(String gslogin) throws Exception {
    return ((dbUser) userht.get(gslogin)).idnum;
  }
  
  //--------------------------------------------------------------------//
  //setIdNumber(  String gslogin,dbUser u) 
  //--------------------------------------------------------------------//
  public synchronized static void setIdNumber(  String gslogin,dbUser u) 
       throws Exception {
    Random r=new Random();
    long id=r.nextLong();
    while (existId(id,gslogin))
      id=r.nextLong();
    /*
    Calendar c=  Calendar.getInstance();
    c.add(Calendar.HOUR_OF_DAY,1);
    */
    u.idnum=Long.toString(id);
    
  }
  //--------------------------------------------------------------------//
  //checkIdExpiration(String gslogin)
  //--------------------------------------------------------------------//
  public  static synchronized void checkIdExpiration(String gslogin) {
  }

  //--------------------------------------------------------------------//
  //existId(long id)
  //--------------------------------------------------------------------//
  public static boolean existId(long id,String gslogin) throws Exception {
    String idnum=Long.toString(id);
    String gsloginDB=dbUser.checkUserID(idnum);
    if (gsloginDB==null ||gsloginDB==gslogin) {
      //check cach also
      return false;
    }
    return true;
  }

  /* //--------------------------------------------------------------------//
  // Browse a user
  //--------------------------------------------------------------------//  
  public static dbUser getUser(String gslogin)  throws Exception
  {
    dbUser u=(dbUser) userht.get(gslogin);
    if (u==null) {
      u= new dbUser(gslogin);
      userht.put(gslogin,u);
    }
    return u;
  }*/
  //--------------------------------------------------------------------//
  // delete user
  //--------------------------------------------------------------------//  
 
  public static void  delete(String gslogin)  throws Exception
  {
    dbUser.delete(gslogin);
    userht.remove(gslogin);

  }
  //--------------------------------------------------------------------//
  // add user
  //--------------------------------------------------------------------//  
 
  public static void  add(dbUser dbu)  throws Exception
  {
    dbu.add();
    userht.put(dbu.gslogin,dbu);
  }
  //--------------------------------------------------------------------//
  // update user
  //--------------------------------------------------------------------//  
 
  public static void  update(dbUser dbu)  throws Exception
  {
    userht.remove(dbu.gslogin);
    dbu.update();
    userht.put(dbu.gslogin,dbu);
  }

}
