package gs.admin;

import java.util.Hashtable;

import java.io.IOException;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpUtils;


import gs.db.update;
import gs.db.dbStudent;
import gs.db.dbUser;
import gs.db.dbSurvey;

import gs.admin.gCourses;

import java.sql.ResultSet;

import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;


/**
 */
public class gStudents extends HttpServlet {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */

  public static int MIN_LOGIN_NAME_LENGTH = 3;
  public static int MIN_PASSWORD_LENGTH = 5;
  public gSystem  sys=new gSystem();



  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//
  // doPost  doGet
  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//  
  public void doPost  (HttpServletRequest req,HttpServletResponse response) 
       throws IOException, ServletException 
  {
    processInOut( req,response);
  }

  public void doGet(HttpServletRequest req, HttpServletResponse response)
       throws IOException, ServletException
  {
    processInOut( req,response);
  }

  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//
  // processInOut
  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//  

  public void processInOut (HttpServletRequest req,HttpServletResponse response)
       throws IOException, ServletException
  {
    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();
    String templateFile = req.getPathTranslated();
    String unum = req.getParameter("unum"); 
    String command = req.getParameter("comm"); 
    String course  = req.getParameter("course");
    String request = req.getParameter("request"); 

    //    out.println( Html.header("Student Records") );
    //    System.out.println( templateFile);
    if (command==null) {
      if ( request==null) {
	unum = req.getParameter("v1"); 
	course  = req.getParameter("v2");
	if (unum==null || course==null)
	  return;
	request ="LOGIN GRADING SYSTEM";
      }

    }

     //System.out.println( "unum - - - > ["+unum+"]" );
     //System.out.println( "comm - - - > ["+command+"]" );
     //System.out.println( "course - - - > ["+course+"]" );
    //System.out.println("req.getParameter(accesscode)---- "+req.getParameter("accesscode"));


     try {
       if ( course==null || unum==null) {
	 String coursename  = req.getParameter("coursename");

	 if (coursename==null ||unum==null ) 
	   throw new Exception("State lost: Unknown course or user!.");
	 String term    = req.getParameter("term");
	 String year    = req.getParameter("year");
	 course=coursename+term+year;
       }
       if (command!=null) {
	 //System.out.println( "command - - - > {"+command+"}" );
	 if(command.equals("BEFORELOGIN"))   {
	   returnMainPage(out, unum, course, req.getPathTranslated());
	   return;
	 }
	 sys.accessPermission(unum,course,"STUDENT_RECORDS:"+command);

	 if (command.equals("MAIN"))
	   returnMainPage(out, unum, course, req.getPathTranslated());

	 else if(command.equals("LIST")) 
	   listStudents(out, unum, course, req.getPathTranslated(), false);
   
	 else if(command.equals("LISTALL"))
	   listStudents(out, unum, course, req.getPathTranslated(), true);


	 else if(command.equals("SHOW"))
	   browseStudent(out, unum, course, req.getPathTranslated(), req.getParameter("accesscode"),"don't reload");

	 else if(command.equals("NEW"))
	   newStudent(out, unum, course, req.getPathTranslated());


	 else if(command.equals("SKIP"))
	   skip(out, unum, course, req.getPathTranslated());

	 else if(command.equals("INFO"))
	   infoPage(out, unum, course, req.getPathTranslated());

	 else if(command.equals("CANCEL")) {
	   out.println("<script language=JavaScript> history.go(-2);</script>");
	   //decideFrame(out, unum, req.getPathTranslated(), 
	   //    "SHOW", 
	   //    "browse.html", req.getParameter("oldaccesscode"));
	 }
	 else if(command.equals("EDIT"))
	   editStudentRecord(out, unum, course, req.getPathTranslated(),
			     (String)(req.getParameter("accesscode")));


	 else if(command.equals("DELETE"))
	   deleteStudent(out, unum, course, req.getPathTranslated(),
			 (String)(req.getParameter("accesscode")), 
			 (String)(req.getParameter("answer")));

	 else if(command.equals("UPDATE")) 
	   updateStudent(out, unum, course, readStudentFields(req), req.getPathTranslated());

	 else if(command.equals("ADD")) 
	   addStudent(out, unum, course, readStudentFields(req) , req.getPathTranslated());

	 else if(command.indexOf("Post Office")>=0) 
	   postOffice(out, unum, course, req.getPathTranslated());
	 else if(command.indexOf("Class List")>=0) 
	   classList(out, unum, course, req.getPathTranslated());



	   //returnPublicPage(out, unum, course, req.getPathTranslated());
      //........................STUDENTS.............................      

       }
       else {
	
	 //System.out.println( "request - - - > {"+request+"}" );
	 try {
	 sys.recordAccess(sys.std_cache.findAccessNumber(unum),course,"STUDENT:"+request);
	 } catch (Exception e) {
	   sys.recordAccess("unknown",course,"STUDENT:"+request);
	 }
	 if(request.equals("LOGIN GRADING SYSTEM")) 
	   returnMainPage(out, unum, course, req.getPathTranslated());

	 else if(request.equals("ACCESS")) 
	   accessPage(out, unum, course, req.getPathTranslated(),
		      (String)(req.getParameter("lgn")),(String)(req.getParameter("pwd")));
	 else if(request.indexOf("Personal Info Access")>=0) 
	   personalInfo(out, unum, course, req.getPathTranslated(),"don't reload");
	   // personalInfo(out,req.getParameter("accesscode"), course, req.getPathTranslated(),"don't reload");
	 else if(request.indexOf("Personal Info Access")>=0) 
	   personalInfo(out, unum, course, req.getPathTranslated(),"don't reload");
	 else if(request.indexOf("Personal Record Update")>=0) 
	   personalRecordUpdate(out, unum, course, req.getPathTranslated());
	 else if(request.equals("UPDATE")) {
	   studentUpdate(out, unum, course, readStudentFields(req), req.getPathTranslated());
	 }
	 else if(request.indexOf("Course Grades Access")>=0) 
	   showGrades(out, unum, course, req.getPathTranslated());
	 else if(request.indexOf("Password Change")>=0) 
	   changePasswordPage(out, unum, course, req.getPathTranslated());
	 else if(request.indexOf("Post Office")>=0) 
	   postOffice(out, unum, course, req.getPathTranslated());
	 else if(request.indexOf("Class List")>=0) 
	   classList(out, unum, course, req.getPathTranslated());
	 else if(request.equals("CHANGE"))
	   changePassword(out, unum, course, req.getParameter("gspwd"), req.getPathTranslated());
	 else if(request.indexOf("Course Survey")>=0) 
	   surveyMenu(out, unum, course, req.getPathTranslated());
	 else if(request.equals("FILL SURVEY"))
	   surveyPage(out, unum, course, req.getPathTranslated(),req.getParameter("surveyname"));
	 else if(request.equals("SURVEYCOMPLETE"))
	   storeSurvey(out, unum, course,  req.getPathTranslated(),req.getParameter("surveyname"),req.getParameter("survey"));

	 else if(request.equals("REGISTRATION")) {
	   registerStudent(out, unum, course,readStudentFields(req),  req.getPathTranslated(),req.getParameter("surveyname"),req.getParameter("survey"));
	 }
       }
     } catch (Exception e) {
       //System.out.println( "Error catched. " );
       // if (e.getMessage()!=null)
	 //System.out.println( e.getMessage());
       //System.out.println( "ERROR CATCHED. " );
       sys.error(out,e);
       // e.printStackTrace();
       // sys.error(out,e.getMessage());
     }
     //out.println( "kapatiyorum");
     //    out.println( Html.footer() );
     out.close();
  
  }


  //--------------------------------------------------------------------//
  //Reads Student fields from the html request form
  //--------------------------------------------------------------------//
  public dbStudent readStudentFields(HttpServletRequest req) throws Exception {

    dbStudent u=new dbStudent();

    String accesscode   = req.getParameter("accesscode"); 
    String firstname = req.getParameter("firstname"); 
    String midname   = req.getParameter("midname");
    String lastname  = req.getParameter("lastname"); 
    String gspwd     = req.getParameter("gspwd"); 
     String confirm   = req.getParameter("confirmgspwd"); 
      
    if(accesscode.equals("") || firstname.equals("") || lastname.equals("") 
       || gspwd.equals("") || confirm.equals("")) 
      throw new Exception("Please enter in all the fields in red!");
    else if (accesscode.length() < gStudents.MIN_LOGIN_NAME_LENGTH) 
      throw new Exception("Students' login names must be at least 3 digits long!");
    else if (!gspwd.equals(confirm)) 
      throw new Exception("Passwords do not match!");
    else if (gspwd.length() < gStudents.MIN_PASSWORD_LENGTH) 
      throw new Exception("Password must be at least 5 characters long!");
    else {
      u.fields.put("course"     , req.getParameter("course"));
      u.fields.put("idnum"     , req.getParameter("idnum"));
      u.fields.put("studentid" , req.getParameter("studentid"));
      u.fields.put("class"       , req.getParameter("class"));
      u.fields.put("email"     , req.getParameter("email")); 
      u.fields.put("dept"      , req.getParameter("dept")); 
      u.fields.put("url"       , req.getParameter("url"));  
      u.fields.put("picurl"    , req.getParameter("picurl"));  
      u.fields.put("systemslogin"   , req.getParameter("systemslogin"));
      u.fields.put("systemspwd"  , req.getParameter("systemspwd"));
      u.fields.put("oldaccesscode"  , req.getParameter("oldaccesscode"));
      
    }
    u.fields.put("accesscode"     , accesscode);    
    u.fields.put("firstname"   , firstname);    
    u.fields.put("midname"     , midname);    
    u.fields.put("lastname"    , lastname);    
    u.fields.put("gspwd"       , gspwd);    
    u.setIdentification();

    return u;

  }
 


  //--------------------------------------------------------------------//
  //returnMainPage(
  //--------------------------------------------------------------------//  
  void returnMainPage(ServletOutputStream out, String unum,String course, String templateFile)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      Parser.parseHtml(templateFile,ht , out);
  }


  //--------------------------------------------------------------------//
  // List ALL students 
  //--------------------------------------------------------------------//  
  void listStudents(ServletOutputStream out, String unum, String course, String templateFile, boolean allFields)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      String fieldNames = "accesscode,firstname,midname,lastname,url";
      String queryProjection = fieldNames;
      dbStudent u = new dbStudent();

      if(allFields) 	{
	fieldNames = u.getFieldNames();
	queryProjection = "*";
      }
      ResultSet rs = u.records(queryProjection,"course='"+course+"'","lastname");
      Parser.parseHtml(templateFile, ht, out,  new RecordParser(rs, fieldNames));
   }
  //--------------------------------------------------------------------//
  // info page
  //--------------------------------------------------------------------//  
  void infoPage(ServletOutputStream out, String unum,String course ,String templateFile) 
       throws Exception,IOException
  {
      Hashtable ht = new Hashtable();
      ht.put("course",course);
      sys.globalValues(ht,unum);
      Parser.parseHtml(templateFile,ht,out);
  }

  //--------------------------------------------------------------------//
  // Browse a student
  //--------------------------------------------------------------------//  
  void browseStudent (ServletOutputStream out, String unum,String course, String templateFile, String accesscode,String reload) 
       throws Exception, IOException
  {
    if(accesscode.length() >= gStudents.MIN_LOGIN_NAME_LENGTH) {
      try {
	//Hashtable ht=dbStudent.getFields( accesscode );
	Hashtable ht=sys.std_cache.get(accesscode,course).getFields();
	sys.globalValues(ht,unum);
	ht.put("course",course);
	ht.put("reload",reload);
	Parser.parseHtml(templateFile,ht , out);
      
      } catch(Exception e) {
	throw new Exception("<h2>ERROR at browsing student "+accesscode+": "+e.getMessage()+"</h2>");
      }
    } else {
      throw new Exception("<h2>ERROR:Illegal student login name '"+accesscode+"'.</h2>");
    }
  }

  //--------------------------------------------------------------------//
  // open new student page 
  //--------------------------------------------------------------------//  
  void newStudent  (ServletOutputStream out, String unum,String course, String templateDir)
       throws  Exception, IOException
  {
      Hashtable ht= new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      Parser.parseHtml(templateDir+"new.html", ht, out);
  }


   //--------------------------------------------------------------------//
  //  editStudentRecord page
  //--------------------------------------------------------------------//  
  void editStudentRecord (ServletOutputStream out, String unum,String course, 
		      String templateDir, String accesscode)        
       throws  Exception, IOException
  {
    //Hashtable ht=dbStudent.getFields(accesscode);
    Hashtable ht=sys.std_cache.get(accesscode,course).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);
    ht.put("accesscode", accesscode);
    ht.put("oldaccesscode", accesscode);

    Parser.parseHtml(templateDir+"edit.html", ht, out);

  }

  //--------------------------------------------------------------------//
  // DELETE a student
  //--------------------------------------------------------------------//  
  void deleteStudent (ServletOutputStream out, String unum,String course,
		   String templateDir, String accesscode, String answer) 
       throws Exception, IOException
  {
    String templateFile=templateDir;;
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      if(answer == null) {

	templateFile+="confirm.html";
	ht.put("message", "<br>Do you really want to delete the student <i>"+accesscode+"</i>?");
	ht.put("actionurl", "updatemessage.html");
	ht.put("comm","DELETE");	
      ht.put("course",course);
	ht.put("accesscode",accesscode);
      } 
      else if(answer.equals("YES")) {
	//dbStudent.delete(accesscode);
	sys.std_cache.delete(accesscode,course);
	ht.put("message", "Student information has been succesfully deleted!");
      }
      else if(answer.equals("NO")) {
	out.println("<script language=JavaScript> history.go(-2);</script>");
      }
      Parser.parseHtml(templateFile, ht, out);
      
  }

  //--------------------------------------------------------------------//
  // add new Student
  //--------------------------------------------------------------------//  
  void addStudent(ServletOutputStream out, String unum,String course, dbStudent dbu, String templateDir )
       throws Exception,IOException
  {
    try {
      //dbu.add();
      sys.std_cache.add(dbu);
      browseStudent(out, unum,course,templateDir+"browse.html",dbu.accesscode,"reload");
	
    } catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	error= new String("This student login id exists in the system. <br> Please try another one.");
	}
      throw new Exception(error);
    }    
  }
  //--------------------------------------------------------------------//
  // add new Student
  //--------------------------------------------------------------------//  

  void registerStudent(ServletOutputStream out, String unum,String course, dbStudent dbu, String templateFile,String surveyname,String survey)
       throws Exception,IOException
  {
    try {
      //dbu.add();
      sys.std_cache.add(dbu); 
      dbSurvey s=new dbSurvey();
      String accesscode= dbu.accesscode;
      s.saveSurvey(accesscode,course,surveyname,survey);      
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      Parser.parseHtml(templateFile,ht , out);
    } catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	error= new String("This student  accesscode exists in the system. <br> Please try another one.");
	}
      throw new Exception(error);
    }    
  }
  //--------------------------------------------------------------------//
  // update student record 
  //--------------------------------------------------------------------//  

  void updateStudent(ServletOutputStream out, String unum,String course, dbStudent dbu,String templateDir)
       throws Exception,IOException
    {
      try {
	Hashtable ht = new Hashtable();
	sys.globalValues(ht,unum);
	//	dbu.update();
	sys.std_cache.update(dbu);
      browseStudent(out, unum,course,templateDir+"browse.html",dbu.accesscode,"reload");
	
      } catch( Exception e ) {
	out.println( Html.header("Student Records") );
	String error =e.getMessage();
	if (error.indexOf("unique") >=0) {
	  error= new String("This student login id exists in the system. <br> Please try another one.");
	}
	throw new Exception(error);
      }   
    }
  //--------------------------------------------------------------------//
  // 
  //--------------------------------------------------------------------//  
  void skip(ServletOutputStream out, String unum,String course,String templateDir) 
       throws Exception,IOException
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
	ht.put("course",course);
      Parser.parseHtml(templateDir+"info.html",ht,out);
  }

  //--------------------------------------------------------------------//
  // STUDENT
  //--------------------------------------------------------------------//  
  void accessPage (ServletOutputStream out, String unum,String course, String templateDir,String accesscode, String gspwd)
       throws Exception, IOException 
  {
    String templateFile=templateDir;
    Hashtable ht=new Hashtable();

     //System.out.println("Check the User Autr ---->>>>>:" +accesscode+gspwd+", kors:"+course);

     try {
       unum=sys.std_cache.accessCheck(course,accesscode,gspwd);
       templateFile +="studentMenu.html";
     } catch(Exception e) { 
        //System.out.println(e.getMessage());
       if (e.getMessage().indexOf("GS:")<0)
	 throw e;
       templateFile +="denied.html";
       unum="unknown";
     }
    sys.globalValues(ht,unum);
    ht.put("course",course);

//System.out.println("templateFile "+templateFile);
//System.out.println("unum "+(String)ht.get("unum"));

    Parser.parseHtml(templateFile,ht , out);
  }
  //--------------------------------------------------------------------//
  // STUDENT
  //--------------------------------------------------------------------//  
   void personalInfo (ServletOutputStream out, String unum,String course, String templateDir,String reload) 
       throws Exception, IOException
  {
    try {
      //Hashtable ht=sys.std_cache.findGet(unum).getFields();
	Hashtable ht=sys.std_cache.getbyID(unum,course).getFields();
	sys.globalValues(ht,unum);
	ht.put("course",course); // it come directly
	ht.put("reload",reload);
	Parser.parseHtml(templateDir+"browse.html",ht , out);
	ht.remove("reload");
      
    } catch(Exception e) {
	throw new Exception("<h2>ERROR at browsing student "+unum+e.getMessage()+"</h2>");
    }
  
  }
  //--------------------------------------------------------------------//
  // STUDENT
  //--------------------------------------------------------------------//  
   //--------------------------------------------------------------------//
  //  editStudentRecord page
  //--------------------------------------------------------------------//  
  void personalRecordUpdate (ServletOutputStream out, String unum,String course, 
		      String templateDir)        
       throws  Exception, IOException
  {
    //Hashtable ht=dbStudent.getFields(accesscode);
    Hashtable ht=sys.std_cache.getbyID(unum,course).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);
    // ht.put("accesscode", accesscode);
    // ht.put("oldaccesscode", accesscode);

    Parser.parseHtml(templateDir+"edit.html", ht, out);

  }

  //--------------------------------------------------------------------//
  // STUDENT
  //--------------------------------------------------------------------//  
  void studentUpdate(ServletOutputStream out, String unum,String course, dbStudent u,String templateDir)
       throws Exception,IOException
  {
    dbStudent old=sys.std_cache.getbyID(unum,course);
    u.fields.put("oldaccesscode"  , old.fields.get("accesscode" ));
    u.fields.put("accesscode"     , old.fields.get("accesscode" ));    
    u.fields.put("gspwd"       , old.fields.get("gspwd" ));    
    u.fields.put("idnum"       , old.fields.get("idnum" ));    
    old.fields=u.fields;
   
    updateStudent(out, unum, course, old, templateDir);
  }
  //--------------------------------------------------------------------//  
  //--------------------------------------------------------------------//
  // STUDENT
  //--------------------------------------------------------------------//  
  void   showGrades(ServletOutputStream out, String unum,String course,  String templateDir)        
       throws  Exception, IOException
  {   
    Hashtable ht=sys.std_cache.getbyID(unum,course).getFields();
    /*    sys.globalValues(ht,unum);
    ht.put("course",course);

 System.out.println("Please implement MEMMMEMMEMEMEM");

    Parser.parseHtml(templateDir+"grades.html", ht, out); */
    gGrading gg=new gGrading();
    gg.showGrades(out,unum,course,(String)ht.get("accesscode"),templateDir+"grades.html","","STUDENT");


  }
  //--------------------------------------------------------------------//
  // STUDENT
  //--------------------------------------------------------------------//  
  void   postOffice(ServletOutputStream out, String unum,String course,  String templateDir)        
       throws  Exception, IOException
  {   
    Hashtable ht=new Hashtable(); //sys.std_cache.getbyID(unum).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);

    //System.out.println("Please implement MEMMMEMMEMEMEM");
    
    dbStudent s=new dbStudent();
    String ofis= s.postOffice(course);
    dbUser u =new dbUser();
    ofis +=u.postOffice(course);
//System.out.println("ofis===?>"+ofis);
    ht.put("office",ofis);
    Parser.parseHtml(templateDir+"postOffice.html", ht, out);

  }
  //--------------------------------------------------------------------//
  // STUDENT
  //--------------------------------------------------------------------//  
  void   classList(ServletOutputStream out, String unum,String course,  String templateDir)        
       throws  Exception, IOException
  {   
    Hashtable ht=new Hashtable(); //sys.std_cache.getbyID(unum).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);

    //System.out.println("Please implement MEMMMEMMEMEMEM");
    
    //Parser.parseHtml(templateDir+"classList.html", ht, out);
    dbStudent s=new dbStudent();
    Parser.parseHtml(templateDir+"classList.html", ht, out,  new RecordParser( s.classList(course),s.classListFields(course)));
 
  }
  //--------------------------------------------------------------------//
  // STUDENT
  //--------------------------------------------------------------------//  
  void changePasswordPage (ServletOutputStream out, String unum,String course, 
		      String templateDir)        
       throws  Exception, IOException
  {
    //Hashtable ht=dbStudent.getFields(accesscode);
    Hashtable ht=sys.std_cache.getbyID(unum,course).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);



    Parser.parseHtml(templateDir+"password.html", ht, out);

  }

  //--------------------------------------------------------------------//
  // STUDENT
  //--------------------------------------------------------------------//  
  void changePassword (ServletOutputStream out, String unum,String course, String gspwd,
		      String templateFile)        
       throws  Exception, IOException
  {
    dbStudent s=sys.std_cache.getbyID(unum,course);
    s.fields.put("gspwd",gspwd);
    s.fields.put("oldaccesscode",s.fields.get("accesscode"));
    s.setIdentification();
    //	dbu.update();
    sys.std_cache.update(s);
    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    Parser.parseHtml(templateFile,ht , out);

  }
  //--------------------------------------------------------------------//
  // STUDENT: SURVEY:surveyMenu
  //--------------------------------------------------------------------//  
  void surveyMenu(ServletOutputStream out, String unum,String course, String templateDir)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      dbSurvey s=new dbSurvey();
      String fieldNames = "surveyname";
      String queryProjection = "DISTINCT surveyname";
      ResultSet rs = s.records(queryProjection,"course='"+course+"'","");
     Parser.parseHtml(templateDir+"survey/surveyMenu.html",ht , out, new RecordParser(rs, fieldNames));
  }

  //--------------------------------------------------------------------//
  // STUDENT: SURVEY:
  //--------------------------------------------------------------------//  
  void surveyPage(ServletOutputStream out, String unum,String course, String templateFile,String surveyname)
       throws Exception, IOException 
  {
    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    ht.put("course",course);
    if (surveyname==null) 
      throw new Exception("Please select an existing  survey first!");
    ht.put("surveyname",surveyname);
    dbSurvey s=new dbSurvey();
    //System.out.println("surveynamecourse " +surveyname +" course");
      Parser.parseHtml(templateFile, ht, out,  new RecordParser(s.surveyQuestions(course,surveyname),s.surveyQuestionsFields(course,surveyname)    ));
    
    //System.out.println("templateFile " +templateFile +" course");
  }

  //--------------------------------------------------------------------//
  // STUDENT: SURVEY:
  //--------------------------------------------------------------------//  
  void  storeSurvey(ServletOutputStream out, String unum,String course, String templateFile,String surveyname,String survey)       throws Exception, IOException 
  {
     //System.out.println("survey====="+survey);
    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    dbSurvey s=new dbSurvey();
    String accesscode= sys.std_cache.findAccessNumber(unum);
    s.saveSurvey(accesscode,course,surveyname,survey);
    Parser.parseHtml(templateFile,ht , out);
     //System.out.println("survey====="+survey);
  }





} //class close

